#! /bin/bash
WINEBIN="bisheng-engine-wine8"
PACKAGE_VERSION="3.0.3"

PACKAGE_NAME="printer-driver-bisheng-deli-m2500d"
PRINTER_NAME=( "Deli M2500D" "Deli M2500ADNW" "Deli M2500ADN" "Deli M2500ADW" "Deli M2500AD" "Deli M2500DN" "Deli M2500DW" "Deli P2500D" "Deli P2500DNW" "Deli P2500DN" "Deli P2500DW" "Deli M2505ADNW" "Deli M2505ADN" "Deli M2505ADW" "Deli P2505DNW" "Deli P2505DN" "Deli P2505DW" "Deli M2020W" "Deli P2020W" "Deli M2020DW" "Deli P2020DW" "Deli M2020W-JD" "Deli M2020DW-JD" "Deli M2000DNW" "Deli M2000DN" "Deli M2000D" "Deli M2000NW" "Deli M2000N" "Deli M2000" "Deli M2000W" "Deli M2000DW" "Deli P2000DNW" "Deli P2000DN" "Deli P2000D" "Deli P2000NW" "Deli P2000N" "Deli P2000" "Deli P2000W" "Deli P2000DW" "Deli M2005DNW" "Deli M2005DN" "Deli M2005D" "Deli M2005NW" "Deli M2005N" "Deli M2005" "Deli M2005W" "Deli M2005DW" "Deli P2005DNW" "Deli P2005DN" "Deli P2005D" "Deli P2005NW" "Deli P2005N" "Deli P2005" "Deli P2005W" "Deli P2005DW" "Deli DM28ADN" "Deli DM28AD" "Deli DM28D" "Deli DP28DN" "Deli DP28D" "Deli DM25DN" "Deli DM25N" "Deli DM25" "Deli DP25DN" "Deli DP25N" "Deli DP25" "Deli P3100D" "Deli P3100DN" "Deli P3100DNW" "Deli M3100D" "Deli M3100DN" "Deli M3100DW" "Deli M3100ADN" "Deli M3100ADNW" "Deli DP31DN" "Deli DM31ADN" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"

WINEPREFIX="$CONTAINER_PATH" $WINEBIN winecfg -v win7
WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "/opt/deepinwine/printer_drv/printer-driver-bisheng-deli-m2500d/winprint.reg"
WINEPREFIX=$CONTAINER_PATH $WINEBIN wineserver -w 
